/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jsf.conventions.bean;

import com.jsf.conventions.event.BundleChangeEvent;
import com.jsf.conventions.qualifier.BundleSulfix;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.enterprise.context.SessionScoped;
import javax.enterprise.event.Event;
import javax.enterprise.inject.Produces;
import javax.faces.model.SelectItem;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author rmpestano
 */
@SessionScoped
@Named
public class BundleBean implements Serializable{
    
    //handles the current bundle sulfix
    private String currentBundle = "en";
    private List<SelectItem> sulfixList;
    @Inject 
    private Event<BundleChangeEvent> bundleChangeEvent;

    public BundleBean() {
        sulfixList  = new ArrayList<SelectItem>(){{add(new SelectItem("en", "English"));add(new SelectItem("pt", "Portuguese"));}};
    }
    
    
    @Produces @BundleSulfix
    public String getCurrentBundle() {
        return currentBundle;
    }

    public void setCurrentBundle(String currentBundle) {
        if(!(this.currentBundle.equals(currentBundle))){
            bundleChangeEvent.fire(new BundleChangeEvent(currentBundle));
            this.currentBundle = currentBundle;
        }
    }
    
    public List<SelectItem> getSulfixList(){
        return sulfixList;
    }

    public void setSulfixList(List<SelectItem> sulfixList) {
        this.sulfixList = sulfixList;
    }
    
    
}
