/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.jsf.conventions.service.impl;

import com.jsf.conventions.qualifier.StatefulService;
import com.jsf.conventions.dao.HibernateDao;
import com.jsf.conventions.qualifier.StatefulHibernateDao;
import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import javax.enterprise.inject.spi.InjectionPoint;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * Stateful EJB based service
 * @author rmpestano
 */
@Named
@StatefulService
public class StatefulHibernateService<T,K extends Serializable> extends BaseServiceImpl<T, K>{

    public StatefulHibernateService() {
    }

    @Inject
    public void StatefulHibernateService(@StatefulHibernateDao HibernateDao<T, K> hibernateDao,InjectionPoint ip) {
          if(ip != null && ip.getAnnotated() != null && ip.getAnnotated().isAnnotationPresent(StatefulService.class)){//when injecting BaseService direct in a bean you will need to pass the PersistentClass via annotation
            Class persistentClass = ip.getAnnotated().getAnnotation(StatefulService.class).entity();
            if(!persistentClass.isPrimitive()){
                hibernateDao.setPersistentClass(persistentClass);
            }
        }
        else{//when you inherit this class (usually when defining your own entity service) you dont need to use @PersistentClass cause it will be resolved via reflection
            hibernateDao.setPersistentClass((Class<T>) ((ParameterizedType) getClass().getGenericSuperclass()).getActualTypeArguments()[0]);
        }
        super.setDao(hibernateDao);
       
    }

}
