/**
 * 
 */
package com.jsf.conventions.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.text.MessageFormat;
import java.util.List;
import java.util.PropertyResourceBundle;

/**
 * Classe para adicionar novas funcionalidades relacionadas a ResourceBundle
 * 
 * @author maicon
 * 
 */
public class ResourceBundleProvider extends PropertyResourceBundle implements
		Serializable {

	private static final long serialVersionUID = -7975658511833622918L;

	/**
	 * 
	 * @param stream
	 *            Arquivo properties
	 * 
	 * @throws IOException
	 */
	public ResourceBundleProvider(InputStream stream) throws IOException {
		super(stream);
	}

	/**
	 * Retorna mensagem formatada com os parâmetros
	 * 
	 * @param key
	 *            Chave do arquivo de propriedades
	 * 
	 * @param params
	 *            Lista de parâmetros que serão concatenados na mensagem.
	 * 
	 * @return Mensagem formatada
	 */
	public String getString(String key, List<Object> params) {
		return MessageFormat.format(this.getString(key), params.toArray());
	}

}
